Loading...
Searching...
No Matches
seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t > Class Template Reference
Alphabet » Structure

A seqan3::alphabet_tuple_base that joins an aminoacid alphabet with a protein structure alphabet. More...

`#include <seqan3/alphabet/structure/structured_aa.hpp>`

Inheritance diagram for seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >:
[legend]

## Public Types

using | char_type = alphabet_char_t<sequence_alphabet_type>
| Equals the char_type of sequence_alphabet_type.
using | sequence_alphabet_type = sequence_alphabet_t
| First template parameter as member type.
using | structure_alphabet_type = structure_alphabet_t
| Second template parameter as member type.

## Public Member Functions

Constructors, destructor and assignment
constexpr | structured_aa () noexcept=default
| Defaulted.
constexpr | structured_aa (structured_aa const &) noexcept=default
| Defaulted.
constexpr | structured_aa (structured_aa &&) noexcept=default
| Defaulted.
constexpr structured_aa & | operator= (structured_aa const &) noexcept=default
| Defaulted.
constexpr structured_aa & | operator= (structured_aa &&) noexcept=default
| Defaulted.
| ~structured_aa () noexcept=default
| Defaulted.
template<typename component_type>
constexpr | structured_aa (component_type const alph)
| Construction via a value of one of the components.
template<typename indirect_component_type>
constexpr | structured_aa (indirect_component_type const alph)
| Construction via a value of a subtype that is assignable to one of the components.
template<typename component_type>
constexpr structured_aa & | operator= (component_type const alph)
| Assignment via a value of one of the components.
template<typename indirect_component_type>
constexpr structured_aa & | operator= (indirect_component_type const alph)
| Assignment via a value of a subtype that is assignable to one of the components.
Write functions
constexpr structured_aa & | assign_char (char_type const c) noexcept
| Assign from a nucleotide character. This modifies the internal sequence letter.
Read functions
constexpr char_type | to_char () const noexcept
| Return a character. This reads the internal sequence letter.
Public Member Functions inherited from seqan3::alphabet_tuple_base< structured_aa< aa27, dssp9 >, aa27, dssp9 >
constexpr structured_aa< aa27, dssp9 > & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr | operator type () const noexcept
| Implicit cast to a single letter. Works only if the type is unique in the type list.
Public Member Functions inherited from seqan3::alphabet_base< structured_aa< aa27, dssp9 >,(1 *... *alphabet_size< component_types >), void >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr structured_aa< aa27, dssp9 > & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr structured_aa< aa27, dssp9 > & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Static Public Member Functions

static constexpr bool | char_is_valid (char_type const c) noexcept
| Validate whether a character is valid in the sequence alphabet.

## Related Symbols

(Note that these are not member symbols.)
template<typename sequence_alphabet_type, typename structure_alphabet_type>
| structured_aa (sequence_alphabet_type &&, structure_alphabet_type &&) -> structured_aa< std::decay_t< sequence_alphabet_type >, std::decay_t< structure_alphabet_type > >
| Type deduction guide enables usage of structured_aa without specifying template args.

## Additional Inherited Members

Static Public Attributes inherited from seqan3::alphabet_tuple_base< structured_aa< aa27, dssp9 >, aa27, dssp9 >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Static Public Attributes inherited from seqan3::alphabet_base< structured_aa< aa27, dssp9 >,(1 *... *alphabet_size< component_types >), void >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Protected Types inherited from seqan3::alphabet_base< structured_aa< aa27, dssp9 >,(1 *... *alphabet_size< component_types >), void >
using | char_type
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>
requires (!std::is_reference_v<sequence_alphabet_t>) && (!std::is_reference_v<structure_alphabet_t>)
class seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >

A seqan3::alphabet_tuple_base that joins an aminoacid alphabet with a protein structure alphabet.

Template Parameters

  sequence_alphabet_t | Type of the first aminoacid letter; must model seqan3::writable_alphabet, seqan3::aminoacid_alphabet and satisfy the requirements on arguments by seqan3::alphabet_tuple_base.
  structure_alphabet_t | Types of further structure letters; must model seqan3::writable_alphabet and satisfy the requirements on arguments by seqan3::alphabet_tuple_base.

This composite pairs an aminoacid alphabet with a structure alphabet. The rank values correspond to numeric values in the size of the composite, while the character values are taken from the sequence alphabet and the structure annotation is taken from the structure alphabet.

As with all seqan3::alphabet_tuple_base s you may access the individual alphabet letters in regular c++ tuple notation, i.e. get<0>(t) and objects can be brace-initialized with the individual members.

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/aminoacid/aa27.hpp>
#include <seqan3/alphabet/structure/dssp9.hpp>
#include <seqan3/alphabet/structure/structured_aa.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
using seqan3::get;
seqan3::structured_aa<seqan3::aa27, seqan3::dssp9> letter{'W'_aa27, 'B'_dssp9};
seqan3::debug_stream << seqan3::to_rank(letter) << ' ' // 199
<< seqan3::to_rank(get<0>(letter)) << ' ' // 22
<< seqan3::to_rank(get<1>(letter)) << '\n'; // 1
seqan3::debug_stream << seqan3::to_char(letter) << ' ' // W
<< seqan3::to_char(get<0>(letter)) << ' ' // W
<< seqan3::to_char(get<1>(letter)) << '\n'; // B
// Modify:
get<0>(letter) = 'V'_aa27;
seqan3::debug_stream << seqan3::to_char(letter) << '\n'; // V
}
aa27.hpp
Provides seqan3::aa27, container aliases and string literals.
seqan3::structured_aa
A seqan3::alphabet_tuple_base that joins an aminoacid alphabet with a protein structure alphabet.
Definition structured_aa.hpp:52
debug_stream.hpp
Provides seqan3::debug_stream and related types.
dssp9.hpp
Provides the dssp format for protein structure.
seqan3::to_char
constexpr auto to_char
Return the char representation of an alphabet object.
Definition alphabet/concept.hpp:381
seqan3::to_rank
constexpr auto to_rank
Return the rank representation of a (semi-)alphabet object.
Definition alphabet/concept.hpp:152
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
seqan3::literals
The SeqAn namespace for literals.
seqan3::get
constexpr auto const & get(configuration< configs_t... > const &config) noexcept
This is an overloaded member function, provided for convenience. It differs from the above function o...
Definition configuration.hpp:412
structured_aa.hpp
Provides the composite of aminoacid with structure alphabets.

This seqan3::alphabet_tuple_base itself fulfills seqan3::alphabet.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## Member Typedef Documentation

## char_type

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>

using seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::char_type = alphabet_char_t<sequence_alphabet_type>

Equals the char_type of sequence_alphabet_type.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## sequence_alphabet_type

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>

using seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::sequence_alphabet_type = sequence_alphabet_t

First template parameter as member type.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## structure_alphabet_type

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>

using seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::structure_alphabet_type = structure_alphabet_t

Second template parameter as member type.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## Constructor & Destructor Documentation

## structured_aa() [1/2]

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>
template<typename component_type>

seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::structured_aa | ( | component_type const | alph | ) |

inline constexpr

Construction via a value of one of the components.

See also
  seqan3::alphabet_tuple_base::alphabet_tuple_base(component_type const alph)

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## structured_aa() [2/2]

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>
template<typename indirect_component_type>

seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::structured_aa | ( | indirect_component_type const | alph | ) |

inline constexpr

Construction via a value of a subtype that is assignable to one of the components.

See also
  seqan3::alphabet_tuple_base::alphabet_tuple_base(indirect_component_type const alph)

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## Member Function Documentation

## assign_char()

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>

structured_aa & seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::assign_char | ( | char_type const | c | ) |

inline constexpr noexcept

Assign from a nucleotide character. This modifies the internal sequence letter.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## char_is_valid()

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>

constexpr bool seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::char_is_valid | ( | char_type const | c | ) |

inline static constexpr noexcept

Validate whether a character is valid in the sequence alphabet.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## operator=() [1/2]

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>
template<typename component_type>

structured_aa & seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::operator= | ( | component_type const | alph | ) |

inline constexpr

Assignment via a value of one of the components.

See also
  seqan3::alphabet_tuple_base::operator=(component_type const alph)

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## operator=() [2/2]

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>
template<typename indirect_component_type>

structured_aa & seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::operator= | ( | indirect_component_type const | alph | ) |

inline constexpr

Assignment via a value of a subtype that is assignable to one of the components.

See also
  seqan3::alphabet_tuple_base::operator=(indirect_component_type const alph)

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## to_char()

template<writable_alphabet sequence_alphabet_t = aa27, writable_alphabet structure_alphabet_t = dssp9>

char_type seqan3::structured_aa< sequence_alphabet_t, structure_alphabet_t >::to_char | ( |  | ) | const

inline constexpr noexcept

Return a character. This reads the internal sequence letter.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

The documentation for this class was generated from the following file:

- structured_aa.hpp

Hide me